"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.index-of");

require("core-js/modules/es.array.is-array");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.map");

require("core-js/modules/es.date.to-string");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.define-properties");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.for-each");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _BarView = _interopRequireDefault(require("./bars/BarView"));

var _getBarLines = _interopRequireDefault(require("./bars/getBarLines"));

var _ChordTexts = _interopRequireDefault(require("./chords/ChordTexts"));

var _utils = require("./chords/utils");

var _Endings = _interopRequireDefault(require("./Endings"));

var _Sections = _interopRequireDefault(require("./Sections"));

var _getTimeSignature = _interopRequireDefault(require("./getTimeSignature"));

var _SvgRenderer = _interopRequireDefault(require("./SvgRenderer"));

var _Selections = _interopRequireDefault(require("./Selections"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var propTypes = {
  width: _propTypes["default"].number.isRequired,
  bars: _propTypes["default"].array.isRequired,
  BarMouseUp: _propTypes["default"].func,
  BarMouseDown: _propTypes["default"].func,
  BarMouseOver: _propTypes["default"].func,
  colorSelected: _propTypes["default"].string,
  colorActive: _propTypes["default"].string,
  activeBar: _propTypes["default"].number,
  selectedBars: _propTypes["default"].array
};

var SvgChordProgression = function SvgChordProgression(props) {
  var barView = new _BarView["default"]({
    width: props.width,
    barsPerLine: 4,
    sub: 10,
    sup: 10,
    margins: {
      top: 20,
      left: 20,
      line: 30,
      right: 20
    },
    bar: {
      padding: {
        top: 25,
        left: 8
      },
      height: 40,
      repetitionLineSpace: 4
    }
  }); // logic in constructor: it won't be updated with a render caused by receiving new props,
  // has to be updated with a 'key' prop change,
  // this is done for performance reasons

  var bars = props.bars.map(function (bar) {
    return (0, _utils.transformChords)(bar);
  }).map(function (bar, i) {
    return barView.setDimensions(bar, i);
  });
  var svg = new _SvgRenderer["default"]();
  var scale = (0, _utils.getChordTextScale)(bars, barView.bar.width);
  var chordTexts = (0, _ChordTexts["default"])(scale);

  var _chordTexts$getSvgEle = chordTexts.getSvgElems(bars, barView),
      startX = _chordTexts$getSvgEle.startX,
      chordTextsSvgElems = _objectWithoutProperties(_chordTexts$getSvgEle, ["startX"]);

  svg.addObject(chordTextsSvgElems);
  svg.addObject((0, _Sections["default"])(bars, barView).getSections());
  svg.addObject((0, _getBarLines["default"])(bars, barView));
  svg.addObject((0, _Endings["default"])(bars, barView).getEndings());
  svg.addTexts((0, _getTimeSignature["default"])(bars, barView));

  var barsRender = function barsRender() {
    var emptyFn = function emptyFn() {};

    var colorSelected = props.colorSelected || "#00f";
    var selectedBars = props.selectedBars || [-1, -1];
    var colorActive = props.colorActive || "#f00";
    var activeBar = props.activeBar === undefined ? -1 : props.activeBar;
    var opacity = 0.4;
    var barMouseDown = props.barMouseDown || emptyFn;
    var barMouseOver = props.barMouseOver || emptyFn;
    var barMouseUp = props.barMouseUp || emptyFn;
    var barComponents = [],
        barProps,
        isSelected,
        isCursorBar;
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      var _loop = function _loop() {
        var _step$value = _slicedToArray(_step.value, 2),
            i = _step$value[0],
            bar = _step$value[1];

        isSelected = i >= selectedBars[0] && i <= selectedBars[1];
        isCursorBar = i === activeBar;
        barProps = {
          key: "bar" + i,
          width: barView.bar.width,
          height: barView.bar.height,
          fill: isCursorBar ? colorActive : isSelected ? colorSelected : "#fff",
          fillOpacity: isSelected || isCursorBar ? opacity : 0,
          strokeOpacity: 0,
          mousedown: function mousedown(e) {
            e.preventDefault();
            barMouseDown(i);
          },
          mouseover: function mouseover(e) {
            e.preventDefault();
            barMouseOver(i);
          },
          mouseup: function mouseup(e) {
            e.preventDefault();
            barMouseUp(i);
          }
        };
        barComponents.push(_objectSpread({}, bar.dimensions, {}, barProps));
      };

      for (var _iterator = bars.entries()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        _loop();
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator["return"] != null) {
          _iterator["return"]();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return barComponents.map(function (props) {
      return _react["default"].createElement("rect", props);
    });
  };

  var selectionsRender = function selectionsRender(selections) {
    if (!selections || !selections.length) return;

    var rects = _Selections["default"].getRects(bars, barView, startX, selections);

    return rects.map(function (props, i) {
      return _react["default"].createElement("rect", _extends({
        key: i
      }, props));
    });
  };

  return _react["default"].createElement("svg", {
    width: props.width,
    height: barView.getHeight(bars.length)
  }, svg.render(), barsRender(), selectionsRender(props.selections));
};

var ChordProgression = function ChordProgression(props) {
  var ref = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)(0),
      _useState2 = _slicedToArray(_useState, 2),
      width = _useState2[0],
      setWidth = _useState2[1];

  (0, _react.useEffect)(function () {
    if (!ref.current || !ref.current.getBoundingClientRect().width) return;
    setWidth(ref.current.getBoundingClientRect().width);
  }, [ref.current]);
  return _react["default"].createElement("div", {
    ref: ref
  }, !!width && _react["default"].createElement(SvgChordProgression, _extends({
    width: width
  }, props)));
};

var _default = ChordProgression;
exports["default"] = _default;